#include <LiquidCrystal.h> // Loads Arduino library



LiquidCrystal lcd(7, 8, 9, 10, 11, 12); //Initialize pins for lcd crystal disply
// Establish pins for user-input buttons (whether direction 1 or 2 is clockwise or counterclockwise depends on which
// terminals are connected to which motor pin so it is up to the user)
const int buttonPin1 = 4; // Starts pump flow in direction 1
const int buttonPin2 = 13; // Starts pump flow in direction 2
const int buttonPin3 = 6; // Stops pump flow
// Establish pins for motor driver
const int motor1pin1 = 2; 
const int motor1pin2 = 3;
// Establish pin used for user to control pump speed
const int analogInPin = A0;
// Establish output pin of user's pump speed input
const int analogOutPin = 5;
// Initialize values from user input
int sensorValue;
int outputValue;
int voltpercent;
// Initialize button states
int buttonState1 = 0;
int buttonState2 = 0;
int buttonState3 = 0;
int lastButtonState1 = 0;
int lastButtonState2 = 0;
int lastButtonState3 = 0;

void setup() {
  // put your setup code here, to run once:
  pinMode(motor1pin1, OUTPUT);
  pinMode(motor1pin2, OUTPUT);
  pinMode(analogOutPin, OUTPUT);
  pinMode(buttonPin1, INPUT);
  pinMode(buttonPin2, INPUT);
  pinMode(buttonPin3, INPUT);
  sensorValue = 0;
  outputValue = 0;
  voltpercent = 0;
  lcd.begin(16,2);
  Serial.begin(9600);
 
}

void loop() {
  // put your main code here, to run repeatedly:   
 sensorValue = analogRead(analogInPin); // Reads voltage from output of potentiometer
 outputValue = map(sensorValue, 0, 1023, 0, 255); // Maps range of potentiometer to range of possible motor speeds
 voltpercent = map(outputValue, 0, 255, 0, 100); // Maps range of speeds to a percentage value to be printed for user feedback
  //Controlling speed (0 = off and 255 = max speed):
 analogWrite(analogOutPin, outputValue); //ENA pin
 // Read the states of all the buttons
 buttonState1 = digitalRead(buttonPin1); 
 buttonState2 = digitalRead(buttonPin2);
 buttonState3 = digitalRead(buttonPin3);
 // Update the speed percent value displayed
 lcd.setCursor(6,0);
 lcd.print("          ");
 lcd.setCursor(6,0);
 lcd.print(voltpercent);
 lcd.print(" %");
 // The next three if statements determine if each button has been pressed
 // button1: Briefly turns off pump, then sets motor1pin1 to high and keeps motor1pin2 low causing pump flow in direction 1
  if (buttonState1 != lastButtonState1) {
    if (buttonState1==HIGH) {
      digitalWrite(motor1pin1, LOW);
      digitalWrite(motor1pin2, LOW);
      delay(2000);
      digitalWrite(motor1pin1, HIGH);
        //delay(2000);
        // Displays pump direction and updates pump speed value
        lcd.setCursor(0,0);
        lcd.print("Dir 1           ");
        lcd.setCursor(6,0);
        lcd.print(voltpercent);
        lcd.print(" %");
    }
    //delay(500);
    }
    // button2: Briefly turns off pump, then sets motor1pin2 to high and keeps motor1pin1 low causing pump flow in direction 2
    if (buttonState2 != lastButtonState2) {
    if (buttonState2==HIGH) {
      digitalWrite(motor1pin1, LOW);
      digitalWrite(motor1pin2, LOW);
      delay(2000);
      digitalWrite(motor1pin2, HIGH);
        //delay(2000);
        // Displays pump direction and updates pump speed value
        lcd.setCursor(0,0);
        lcd.print("Dir 2           ");
        lcd.setCursor(6,0);
        lcd.print(voltpercent);
        lcd.print(" %");
    }
//delay(500);
}
// button3: Sets both motor1pin1 and motor1pin2 to low which turns pump off
if (buttonState3 != lastButtonState3) {
    if (buttonState3==HIGH) {
      digitalWrite(motor1pin1, LOW);
      digitalWrite(motor1pin2, LOW);
      // Display that pump is set to off and update what the speed will be once it is turned on again
        lcd.setCursor(0,0);
        lcd.print("Off           ");
        lcd.setCursor(6,0);
        lcd.print(voltpercent);
        lcd.print(" %");
    }
}
// Update button states
 lastButtonState1 = buttonState1;
 lastButtonState2 = buttonState2;
 lastButtonState3 = buttonState3;
 delay(500);
  }
  
  
